<?php
$pluginData[aqayepardakht][type] = 'payment';
$pluginData[aqayepardakht][name] = 'آقای پرداخت';
$pluginData[aqayepardakht][uniq] = 'aqayepardakht';
$pluginData[aqayepardakht][description] = '<a href="https://aqayepardakht.ir/" target="_blank">آقای پرداخت</a>';
$pluginData[aqayepardakht][author][name] = 'آقای پرداخت';
$pluginData[aqayepardakht][author][url] = 'https://aqayepardakht.ir';
$pluginData[aqayepardakht][author][email] = 'info@aqayepardakht.ir';

$pluginData[aqayepardakht][field][config][1][title] = 'شناسه درگاه';
$pluginData[aqayepardakht][field][config][1][name] = 'pin';

function gateway__aqayepardakht($data)
{
    global $config, $db, $smarty, $ws_config;
    $amount     = round($data[amount]/10);
    $order_id	= $data[invoice_id];

    $p = $db->fetch('SELECT `payment_id`, `payment_email`, `payment_mobile` FROM `payment` WHERE `payment_rand` = "' . $order_id . '" LIMIT 1;');
    $callback	= $data[callback] . '&order_id=' . $order_id . '&payment_id=' . $p[payment_id];

    try
    {
        $err = false;
        $description = "شماره سفارش خریدار : {$order_id}";
        $description .= !empty($p[payment_email]) ? "\nایمیل خریدار : {$p[payment_email]}" : '';
        $description .= !empty($p[payment_mobile]) ? "\nتلفن همراه خریدار : {$p[payment_mobile]}" : '';

        $f = array(
            'amount' => $amount,
            'pin' => $data[pin],
            'callback' => $callback,
            'description' => $description
        );

        $f_ = '';
        foreach($f as $k=>$v)
            $f_ .= $k . '=' . urlencode($v) . '&';

        rtrim($f_, '&');

        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/create/");
        curl_setopt($ch,CURLOPT_POST, count($f));
        curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
        $res = curl_exec($ch);
        curl_close($ch);
        if (!$res)
            $err = 'اتصال به بانک برقرار نشد .';
        else
        {
            if(strlen($res) > 5)
            {
                $update[payment_rand]= $res;
                $sql = $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "'.$order_id.'" LIMIT 1;');
                $db->execute($sql);
                header("Location: https://panel.aqayepardakht.ir/startpay/{$res}");
                exit;
            }
            else
                $err = $res;
        }
    }
    catch (Exception $e)
    {
        $err = 'اتصال به بانک برقرار نشد .';
    }

    if($err)
    {
        $data[title] = 'خطای سیستمي';
        $data[message]= $err;
        $query	= 'SELECT * FROM `config` WHERE `config_id` = "1" LIMIT 1';
        $conf	= $db->fetch($query);
        $smarty->assign('config', $conf);
        $smarty->assign('data', $data);
        $smarty->display('message.tpl');
    }
}

function callback__aqayepardakht($data)
{
    global $db, $get, $ws_config;
    $p_id = (int) $get['payment_id'];

    $sql = 'SELECT * FROM `payment` WHERE `payment_id` = "' . $p_id . '" LIMIT 1;';
    $payment 	= $db->fetch($sql);

    if(empty($payment))
    {
        $output[status]	= 0;
        $output[message]= 'سفارشی با این مشخصات یافت نشد .';
    }
    else if($payment[payment_status] == 1)
    {
        $au = $payment[payment_rand];
        $amount	= round($payment[payment_amount]/10);

        $res = false;
        try
        {
            $f = array(
                'amount' => $amount,
                'pin' => $data[pin],
                'transid' => $au,
            );

            $f_ = '';
            foreach($f as $k=>$v)
                $f_ .= $k . '=' . urlencode($v) . '&';

            rtrim($f_, '&');

            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/verify/");
            curl_setopt($ch,CURLOPT_POST, count($f));
            curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
            $res = curl_exec($ch);
            curl_close($ch);
        }
        catch(Exception $e)
        {
            $res = false;
        }

        if(empty($res))
        {
            $output[status]	= 0;
            $output[message]= 'پرداخت انجام نشده است .';
        }
        else if($res == 1)
        {
            $output[status]		= 1;
            $output[res_num]	= (int) $get['order_id'];
            $output[ref_num]	= $au;
            $output[payment_id]	= $payment[payment_id];
        }
        else
        {
            $output[status]	= 0;
            $output[message]= 'پرداخت  انجام نشده است . <br /> شرح خطا : ' . $res;
        }
    }
    else
    {
        $output[status]	= 0;
        $output[message]= 'سفارش قبلا پرداخت شده است.';
    }
    return $output;
}